
--
--  ReQuest
--    by Tuhljin
--

local DEBUG = false

local L = REQUEST_STRINGS
ReQuest = {}

local OPT
local playerName

local frame = CreateFrame("Frame")
ReQuest.Frame = frame
frame:Hide()


local function chatprint(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, LIGHTYELLOW_FONT_COLOR:GetRGB()); --NORMAL_FONT_COLOR
end

local function isWorldQuest(id)
	--local tagID, tagName, worldQuestType, rarity, isElite, tradeskillLineIndex, displayTimeLeft = GetQuestTagInfo(questID)
	local _, worldQuestType
	_, _, worldQuestType = GetQuestTagInfo(id)
	return not not worldQuestType
	--return QuestUtils_IsQuestWorldQuest(id) --?
end

local function OnEvent(self, event, ...)
	if (event == "QUEST_TURNED_IN") then
		local questID = ...
		if (isWorldQuest(questID)) then
			if (DEBUG) then  chatprint("RQC: World quest " .. questID .. " completed.");  end
			ReQuest_WQComplete[questID] = (ReQuest_WQComplete[questID] or 0) + 1
			ReQuest_WQComplete_Char[questID] = (ReQuest_WQComplete_Char[questID] or 0) + 1
		elseif (DEBUG) then
			chatprint("RQC: NON-world quest " .. questID .. " completed.")
		end
	end
end

frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, arg1)
	if (arg1 == "ReQuest") then
		frame:UnregisterEvent("ADDON_LOADED")
		ReQuest.CreateOptions()
		OPT = ReQuest_Settings

		playerName = UnitName("player")

		if (not ReQuest_WQComplete) then
			ReQuest_WQComplete = {}
		end
		if (not ReQuest_WQComplete_Char) then
			ReQuest_WQComplete_Char = {}
		end

		frame:SetScript("OnEvent", OnEvent)
		frame:RegisterEvent("QUEST_TURNED_IN")
	end
end)


--[[
hooksecurefunc("TaskPOI_OnEnter", function(self)
	if (not self.worldQuest) then  return;  end

	local wqID = OPT.showWQID and L.WORLDQUEST_ID:format(self.questID)
	local wqCom
	if (OPT.showWorldQuestCompleteCount) then
		local count = 1
		wqCom = count == 0 and L.WORLDQUEST_COMPLETECOUNT_ZERO or L.WORLDQUEST_COMPLETECOUNT_NUM:format(1)
	end
	if (not wqID and not wqCom) then  return;  end

	WorldMapTooltip:AddLine(" ")
	if (wqID and wqCom) then
		WorldMapTooltip:AddDoubleLine(wqCom, wqID)
	elseif (wqID) then
		WorldMapTooltip:AddLine(wqID)
	elseif (wqCom) then
		WorldMapTooltip:AddLine(wqCom)
	end

	WorldMapTooltip:Show();
	--WorldMapTooltip.recalculatePadding = true;
end)
--]]


local function addWQCountText(tab, tooltip, questID, global, rightSide, skipZero)
	local msg, r, g, b
	local count = tab[questID] or 0
	--DEBUG --count = global and 2 or 0
	if (count == 0) then
		if (skipZero) then  return false;  end
		msg = global and L.WORLDQUEST_COMPLETECOUNT_GLOBAL_ZERO or L.WORLDQUEST_COMPLETECOUNT_CHAR_ZERO:format(playerName)
		r, g, b = RED_FONT_COLOR:GetRGB()
	else
		msg = global and L.WORLDQUEST_COMPLETECOUNT_GLOBAL_NUM:format(count) or L.WORLDQUEST_COMPLETECOUNT_CHAR_NUM:format(playerName, count)
		--r, g, b = 0.2, 0.5, 0.2  -- |cff338033 --lighter: GREEN_FONT_COLOR:GetRGB()
		r, g, b = 0.1, 0.5, 0.1
	end
	if (rightSide) then
		tooltip:AddDoubleLine(msg, rightSide, r, g, b, LIGHTGRAY_FONT_COLOR:GetRGB())
	else
		tooltip:AddLine(msg, r, g, b)
	end
	return count
end


local function updateTooltip(tooltip, questID, idFirst)
	if (isWorldQuest(questID)) then
		local wqID = OPT.showWQID and L.WORLDQUEST_ID:format(questID)
		local wqGlobal, wqChar = OPT.showWQCompleteCount_global, OPT.showWQCompleteCount_char
		if (wqID or wqGlobal or wqChar) then
			tooltip:AddLine(" ")
			local prevZero
			if (wqGlobal) then
				if (wqID and not idFirst) then
					if (not wqChar) then
						idFirst = true
					else
						local here = ReQuest_WQComplete[questID] or 0
						if (here == 0) then  idFirst = true;  end
					end
				end
				local ret = addWQCountText(ReQuest_WQComplete, tooltip, questID, true, idFirst and wqID)
				if (idFirst and ret ~= false) then  wqID = nil;  end
				if (ret == 0) then  prevZero = true;  end
			end
			if (wqChar) then
				local ret = addWQCountText(ReQuest_WQComplete_Char, tooltip, questID, false, wqID, prevZero)
				if (ret ~= false) then  wqID = nil;  end
			end
			if (wqID) then
				tooltip:AddLine(wqID, LIGHTGRAY_FONT_COLOR:GetRGB())
			end
			return true
		end
	end
	return false
end


-- ADD TO TOOLTIP FROM ICONS ON WORLD MAP:

-- We intercept adding quest rewards because we need to put our lines before the reward. We do this instead of adding them last since, if the reward is an item,
-- trying to add our lines last ends up putting them *between* the line "Rewards" and the actual item(s) rewarded.

local orig_GameTooltip_AddQuestRewardsToTooltip = GameTooltip_AddQuestRewardsToTooltip
GameTooltip_AddQuestRewardsToTooltip = function(tooltip, questID, style, ...)
	updateTooltip(tooltip, questID, true)
	return orig_GameTooltip_AddQuestRewardsToTooltip(tooltip, questID, style, ...)
end


-- ADD TO TOOLTIP FROM OBJECTIVE TRACKER:

hooksecurefunc("BonusObjectiveTracker_ShowRewardsTooltip", function(block)
	if (not GameTooltip:IsShown()) then  return;  end
	local isWorldQuest = block.module.ShowWorldQuests
	if (isWorldQuest) then
		local questID = block.id
		if (updateTooltip(GameTooltip, questID, false)) then
			GameTooltip:Show()
		end
	end
end)



-- SLASH COMMANDS
-------------------

local function setCompleteCounts(ids, amount)
	assert(type(amount) == "number" and amount >= 0, "setCompleteCount(): Amount must be a positive number or zero.")
	local tabGlobal, tabChar = ReQuest_WQComplete, ReQuest_WQComplete_Char
	local cNew = amount
	if (amount == 0) then  cNew = nil;  end
	local done = 0
	for id in pairs(ids) do
		local g, c = tabGlobal[id] or 0, tabChar[id] or 0
		if (c ~= amount or (g < amount)) then
			local adj = amount - c  -- Can be positive or negative. If the new amount is higher than before, it's positive; negative if lower.
			local gNew = g + adj
			if (gNew < amount) then  gNew = amount;  end
			if (gNew == 0) then  gNew = nil;  end
			tabChar[id] = cNew
			tabGlobal[id] = gNew
			--print("c","g",cNew,gNew)
		end
		done = done + 1
	end
	return done
end


local function splitOnSpaces(s)
	local tbl = {}
	for v in string.gmatch(s, "[^ ]+") do
		tinsert(tbl, strtrim(v))
	end
	return tbl
end

local function getQuestIDs(links, tab)
	local ids = tab or {}
	for id in gmatch(links, "quest:(%d+):") do  -- Extract from quest links
		id = tonumber(id)
		ids[id] = true
	end
	return ids
	--local questID = strmatch(links, "quest:(%d+):")
end

local function processCommand(msg)
	msg = msg:gsub(",", "") -- Remove commas to make this more friendly to lists
	args = splitOnSpaces(msg)
	local size = #args
	if (size < 3 or strlower(args[size - 1]) ~= "to") then  return false;  end
	local value = tonumber(args[size])
	if (not value or value < 0) then  return false;  end

	local ids = {}
	local num = 0
	for i = 1, size - 2 do
		local s = args[i]
		local id = tonumber(s)
		if (id) then
			ids[id] = true
		else
			getQuestIDs(s, ids)
		end
	end
	for id in pairs(ids) do
		if (not isWorldQuest(id)) then
			local link = GetQuestLink(id)
			if (link) then
				chatprint(L.CMD_LINK_NOT_WQ:format(link))
			else
				chatprint(L.CMD_ARG_NOT_WQ:format(id))
			end
			return 0
		end
	end

	local done = setCompleteCounts(ids, value)

	chatprint(L.CMD_COMPLETECOUNT_UPDATED:format(done))
	return true
end

SLASH_ReQuest1 = "/rq";
function SlashCmdList.ReQuest(msg, obj)
	if (not processCommand(msg)) then
		chatprint(L.CMD_USAGE)
	end
end

