
REQUEST_STRINGS = {
	OPT_WORLDQUEST_COMPLETECOUNT_GLOBAL = "Show global completion count for world quests";
	OPT_WORLDQUEST_COMPLETECOUNT_GLOBAL_TIP = "Add the number of times you've completed a world quest to its tooltip on the map. Includes all of your characters.";
	OPT_WORLDQUEST_COMPLETECOUNT_GLOBAL_TIP2 = "Only includes times completed while ReQuest was enabled (and any added manually using \"/rq\").";
	OPT_WORLDQUEST_COMPLETECOUNT_CHAR = "Show current character's completion count for world quests";
	OPT_WORLDQUEST_COMPLETECOUNT_CHAR_TIP = "Add the number of times the current character has completed a world quest to its tooltip on the map.";
	OPT_WORLDQUEST_COMPLETECOUNT_CHAR_TIP2 = "Omitted if the global count is shown and it is zero.|n|nOnly includes times completed while ReQuest was enabled (and any added manually using \"/rq\").";
	OPT_WORLDQUEST_ID = "Show IDs of world quests";

	WORLDQUEST_ID = "ID: |cffbfbfbf%s|r";
	WORLDQUEST_COMPLETECOUNT_GLOBAL_NUM = "Completed|cff20ff20 %s|r |4time:times;";
	WORLDQUEST_COMPLETECOUNT_GLOBAL_ZERO = "Never completed";
	WORLDQUEST_COMPLETECOUNT_CHAR_NUM = "|cff508050%s:|r Completed|cff20ff20 %s|r |4time:times;";
	WORLDQUEST_COMPLETECOUNT_CHAR_ZERO = "|cffcc1919%s:|r Never completed";

	CMD_USAGE = "|cffffd200ReQuest|r -- Usage:|nSet current character's quest completion count for a quest:|n    |cffffffff/rq |cffc7e7ff<quests>|cffffffff to |cffc7e7ff<number>|r|n|cffc7e7ff<quests>|r can be a number, a |cffffff19[Quest Link]|r, or multiple of these.|nYou can link several quests at once to set their values at the same time.|n|cffc7e7ff<number>|r must be a positive integer or 0.";
	-- |cffffff00[Quest Link] --grey: 999999  87abff
	CMD_LINK_NOT_WQ = "Could not proceed. %s is not a world quest.";
	CMD_ARG_NOT_WQ = "Could not proceed. Provided ID \"%s\" does not correspond to a world quest.";
	CMD_COMPLETECOUNT_UPDATED = "Updated completion counts for %s |4quest:quests;.";
}

local L, locale = REQUEST_STRINGS, GetLocale()

if (locale == "deDE") then  -- German
--@localization(locale="deDE", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "frFR") then  -- French
--@localization(locale="frFR", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "zhTW") then  -- Traditional Chinese
--@localization(locale="zhTW", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "zhCN") then  -- Simplified Chinese
--@localization(locale="zhCN", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "ruRU") then  -- Russian
--@localization(locale="ruRU", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "koKR") then  -- Korean
--@localization(locale="koKR", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "esES" or locale == "esMX") then  -- Spanish
--@localization(locale="esES", format="lua_additive_table", handle-subnamespaces="none")@

	if (locale == "esMX") then  -- Spanish (Mexican)
--@localization(locale="esMX", format="lua_additive_table", handle-subnamespaces="none")@
	end

elseif (locale == "ptBR") then  -- Brazilian Portuguese
--@localization(locale="ptBR", format="lua_additive_table", handle-subnamespaces="none")@

elseif (locale == "itIT") then  -- Italian
--@localization(locale="itIT", format="lua_additive_table", handle-subnamespaces="none")@

end
